#include <stdio.h>
#include <string.h>

#include "../include/conf.c"

#define BUFSIZE 160

int main(int argc, char *argv[])
{
int i, j ,k, FlagN;
FILE *table, *kernel, *util, *make;
char Table [] = "syscall.tbl";
char KLib [] = "syskern.asm";
char buf [BUFSIZE];
char s1 [BUFSIZE];
char s2 [BUFSIZE];
char s3 [BUFSIZE];
char Module [BUFSIZE];
char Proc [] =
"\
; Do not edit this file.\n\
; This file is automatically generated\n\n\
\tmodel tiny\n\
\t.code\n\
%s:\tmov\tax,%i\n\
\tint\t0%02Xh\n\
\tret\n\
\tpublic\t%s\n\
\tend\n";

char do_not_edit [] = "\
%s Do not edit this file.\n\
%s This file is automatically generated\n\n";

if (argc<2)
{
puts("usage: gentbl CommandSourcePath [-n]\n\
-n - no overwrite existing modules *.asm");
return 1;
}

if (argc==3)
  if (!strcmp(argv[2],"-n")) FlagN=1;
  else FlagN=0;

puts("\n\tGenTbl v. 0.0.0.3 24-Mar-96 Generate System Calls\n");

/* History
0.0.0.3 24-Mar-96
0.0.0.2 13-Dec-95
*/

buf[0]=0;

if((table=fopen(Table,"rt"))==NULL)
  {printf("Can't open %s\n",Table);return 2;}

if((kernel=fopen(KLib,"wt"))==NULL)
  {printf("Can't open %s\n",KLib);return 2;}

sprintf(Module,"%s\\syscall.h",argv[1]);
if((make=fopen(Module,"wt"))==NULL)
  {printf("Can't open %s\n",Module);return 2;}
if(fprintf(make,do_not_edit,";",";")==EOF)
  {printf("Can't write %s\n",Module);return 2;}
if(fprintf(make,"INT_NO\tequ\t0%02Xh\n",INT_NO)==EOF)
  {printf("Can't write %s\n",Module);return 2;}

if(fprintf(kernel,do_not_edit,";",";")==EOF)
  {printf("Can't write %s\n",KLib);return 2;}

for(i=0;;)
  {
  if(fgets(buf,BUFSIZE,table)==NULL) break;
  switch (buf[0])
    {
    case '\n':
    case ' ' :
    case ';' :
    case 0   : continue;
    }
  s3[0]=0;
  sscanf(buf,"%s %s %s",s1,s2,s3);
  if (!s3[0]) strcpy(s3,s1);
  if(fprintf(kernel,"extrn\t%s:near\ndw\t%s,_TEXT:%s\n",s3,s2,s3)==EOF)
    {printf("Can't write %s\n",KLib);return 2;}
  if(fprintf(make,"%s\tequ\t%03i\n",s1+1,i)==EOF)
    {printf("Can't write %s\n",Module);return 2;}

  sprintf(Module,"%s\\%03i.ASM",argv[1],i);
  if (FlagN)
    if((util=fopen(Module,"rt"))!=NULL)
      {
      fclose(util);
      printf("System Call %03i %013s existing.  Not rewrited.\n",i,s1);
      goto LL;
      }
  if((util=fopen(Module,"wt"))==NULL)
    {printf("Can't open %s\n",Module);return 2;}
  if(fprintf(util,Proc,s1,i,INT_NO,s1)==EOF)
    {printf("Can't write %s\n",Module);return 2;}
  if(fclose(util))
    {printf("Can't close %s\n",Module);}

  if (strcmp(s1,s3)) printf("System Call %03i %s %s\n",i,s1,s3);
  else printf("System Call %03i %s\n",i,s1);
  LL:
  i++;
  }

if(fclose(table))
  {printf("Can't close %s\n",Table);
  }

if(fclose(kernel))
  {printf("Can't close %s\n",KLib);
  }

if(fclose(make))
  {printf("Can't close %s\n",Module);
  }

puts("");
sprintf(Module,"%s\\tlib.cmd",argv[1]);
printf("Generate %s\n",Module);
if((make=fopen(Module,"wt"))==NULL)
  {printf("Can't open %s\n",Module);return 2;}

for (j=0;j<i;)
  {
  for (k=1;k<=15;k++)
    {
    if(fprintf(make,"-+%03i",j++)==EOF) goto L2;
    if (i==j) break;
    }
  if (i==j) if (fprintf(make,"\n\n")==EOF) goto L2; else;
  else if(fprintf(make," &\n")==EOF)
         {L2:printf("Can't write %s\n",Module);return 2;}
  }

if(fclose(make))
  {printf("Can't close %s\n",Module);
  }

sprintf(Module,"%s\\makefile.1",argv[1]);
printf("Generate %s\n",Module);
if((make=fopen(Module,"wt"))==NULL)
  {printf("Can't open %s\n",Module);return 2;}

if(fprintf(make,do_not_edit,"#","#")==EOF) goto L1;
if(fprintf(make,"Members=\\\n")==EOF) goto L1;

for (j=0;j<i;)
  {
  for (k=1;k<=9;k++)
    {
    if(fprintf(make,"%03i.obj ",j++)==EOF) goto L1;
    if (i==j) break;
    }
  if (i==j) if (fprintf(make,"\n\n")==EOF) goto L1; else;
  else if(fprintf(make,"\\\n")==EOF)
         {L1:printf("Can't write %s\n",Module);return 2;}
  }

if(fclose(make))
  {printf("Can't close %s\n",Module);
  }

printf("\nGenerate finished. Total %03i system calls\n\n",--i);
exit(0);
}
